//+------------------------------------------------------------------+
//|                                                 RangeBars_v2.mq4 |
//|                                Copyright  2008, TrendLaboratory |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#property indicator_chart_window
#property indicator_buffers   4
#property indicator_color1    LightBlue
#property indicator_color2    Tomato
#property indicator_width1    1
#property indicator_width2    1
#property indicator_color3    LightBlue
#property indicator_color4    Tomato
#property indicator_width3    3
#property indicator_width4    3
//---- input parameters
extern double  RangePercent = 33; 

//---- buffers
double UpBar[];
double DnBar[];
double UpBody[];
double DnBody[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
//---- indicators
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,UpBar);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(1,DnBar);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(2,UpBody);
   SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(3,DnBody);


//---- name for DataWindow and indicator subwindow label
   string short_name="RangeBar("+RangePercent+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"Up Bar");
   SetIndexLabel(1,"Down Bar");
   SetIndexLabel(2,"Up Body");
   SetIndexLabel(3,"Down Body");

//----
   
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int      shift, limit, counted_bars=IndicatorCounted();
//---- 
   if (counted_bars < 0) return(-1);
   if (counted_bars ==0) limit=Bars-1;
   if (counted_bars < 1) 
      for(int i=Bars-1; i>=0; i--)
      {
      UpBar[i] = EMPTY_VALUE;
      DnBar[i] = EMPTY_VALUE;
      UpBody[i] = EMPTY_VALUE;
      DnBody[i] = EMPTY_VALUE;
      }      
   if(counted_bars>0) limit=Bars-counted_bars;
   limit--;
   
   for( shift=limit; shift>=0; shift--)
   {
      if(RangePercent > 0)
      {
      double cRange = (High[shift] - Low[shift])*RangePercent/100;
         if (High[shift] - Close[shift] < cRange && Open[shift] - Low[shift] < cRange)
         {
         UpBar[shift] = High[shift];
         DnBar[shift] = Low[shift];
         UpBody[shift] = Close[shift];
         DnBody[shift] = Open[shift];
         }
         else
         if (Close[shift] - Low[shift] < cRange && High[shift] - Open[shift] < cRange)
         {
         UpBar[shift] = Low[shift];
         DnBar[shift] = High[shift];
         UpBody[shift] = Close[shift];
         DnBody[shift] = Open[shift];
         } 
         else
         {
         UpBar[shift] = EMPTY_VALUE;
         DnBar[shift] = EMPTY_VALUE; 
         UpBody[shift] = EMPTY_VALUE;
         DnBody[shift] = EMPTY_VALUE;
         }
      }   
   }
//----
   return(0);
}

